<?php
namespace Financeiro\Logic\ControleBancario\SituacaoCheque;

//use Financeiro\Repositories\Cheque;
use Financeiro\Entities\Cheque;

class SituacaoCheque {
	
	const ENV_VAR_SITUACAO_CHEQUE = 'DADOS_PBI00171_000';
	const POPUP_SITUACAO_CHEQUE = 'win_pbi00171_000';
	
	/**
	 * Abre a popup de situação de cheque
	 * 
	 * @param unknown $cdreducont
	 * @param unknown $nrtranbanc
	 * @param unknown $nrcheque
	 * @param unknown $cdempresa
	 * @param unknown $metodo Caminho do método do botão confirmar
	 */
	public static function abreSituacaoCheque($cdreducont, $nrtranbanc, $nrcheque, $cdempresa) {
		$dados = array(
				'CDREDUCONT'=> $cdreducont,
				'NRTRANBANC' => $nrtranbanc,
				'NRCHEQUE' => $nrcheque,
				'CDEMPRESA' => $cdempresa,
		);
	
		//envia os parâmetros para a próxima Window
		tk_set_env_var(self::ENV_VAR_SITUACAO_CHEQUE, $dados);
	
		tk_open_window(self::POPUP_SITUACAO_CHEQUE, true);
	}
	
	/**
	 * Altera situação de cheque disponível
	 * @param unknown $cdreducont
	 * @param unknown $nrcheque
	 * @throws Exception
	 */
	public static function alteraSituacaoChequeDisp($cdreducont, $nrcheque) {
		try{
            $where = array($cdreducont, $nrcheque);
			$cheque = Cheque::getObjectByWhere('CDREDUCONT = ? AND NRCHEQUE = ?', $where);
            //$cheque = Cheque::findOneByCdreducontAndNrcheque($cdreducont, $nrcheque);
			$cheque->setIdstcheque('0');
			$cheque->setIdtpcanccheq('');
			$cheque->setDtmovbancheq(null);
			$cheque->setDtemischeq(null);
			$cheque->setDsnomcheq('');
			$cheque->setVrcheque(0);
			$cheque->setCdmoticanc(null);
			$cheque->persist();
			\Setforms2\Shared\Registry::getEntityManager()->flush();
		}catch(\Exception $e){
			throw $e;
		}
	}
	
	/**
	 * Altera situação de cheque cancelado
	 * @param unknown $cdreducont
	 * @param unknown $nrcheque
	 * @throws Exception
	 */
	public static function alteraSituacaoChequeCanc($cdreducont, $nrcheque, $motivocanc) {
		try{
			$cheque = Cheque::findOneByCdreducontAndNrcheque($cdreducont, $nrcheque);
			$cheque->setIdstcheque('2');
			$cheque->setIdtpcanccheq('TRAN');
			$cheque->setDtmovbancheq(null);
			$cheque->setCdmoticanc($motivocanc);
			$cheque->persist();
			\Setforms2\Shared\Registry::getEntityManager()->flush();
	
		}catch(\Exception $e){
			throw $e;
		}
	}
}