/* Tabela NUMERORNF */
/* Descrio: A trigger insere registros na tabela LOGOPERAESPE a partir de alteraes na tabela NUMERORNF */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela NUMERORNF
             utilizando a tabela Geral de Logs de Operaes especficas*/
/* Criao:
/* 24/05/2007 - Fabrcio Marcelo Silva */


CREATE OR REPLACE TRIGGER SDXLOG_GERARNF
AFTER INSERT ON NUMERORNF FOR EACH ROW
DECLARE
   V_IDUTLOGGERARNF   VARCHAR2(1);
   V_IDTIPOOPER       VARCHAR2(1);  /* V_IDTIPOOPER - 'I' - Incluso */
   V_CLIENT_INFO      VARCHAR2(64);
   V_CDOPERADOR       VARCHAR2(12);
   V_CDFILIAL         VARCHAR2(4);
   V_DESC             VARCHAR2(100);
   V_TIPOOPERNF       VARCHAR2(50);
BEGIN
   BEGIN
      SELECT IDUTLOGGERARNF
      INTO V_IDUTLOGGERARNF
      FROM PARAMGERAL
      WHERE CDPARGERAL = '0001';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTLOGGERARNF := 'N';
   END;

   IF V_IDUTLOGGERARNF = 'S' THEN

      V_IDTIPOOPER  := '';
      V_CLIENT_INFO := '';
      V_CDOPERADOR  := '';
      V_CDFILIAL    := '';
      V_DESC        := '';
      V_TIPOOPERNF  := '';

      /* Retorna o codigo e o nome do operador */
      DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
      V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,1,12);

      IF :NEW.IDTIPOOPERNF = 'E' THEN
         V_TIPOOPERNF := 'Entradas';
      ELSIF :NEW.IDTIPOOPERNF = 'V' THEN
         V_TIPOOPERNF := 'Saidas - Vendas a vista';
      ELSIF :NEW.IDTIPOOPERNF = 'P' THEN
         V_TIPOOPERNF := 'Saidas - Vendas a prazo';
      ELSIF :NEW.IDTIPOOPERNF = 'T' THEN
         V_TIPOOPERNF := 'Saidas - Transferencias';
      ELSIF :NEW.IDTIPOOPERNF = 'D' THEN
         V_TIPOOPERNF := 'Saidas - Devolucoes';
      ELSIF :NEW.IDTIPOOPERNF = 'S' THEN
         V_TIPOOPERNF := 'Saidas Consolidada';
      ELSIF :NEW.IDTIPOOPERNF = 'C' THEN
         V_TIPOOPERNF := 'Compras a vista';
      ELSIF :NEW.IDTIPOOPERNF = 'F' THEN
         V_TIPOOPERNF := 'Entradas - Transferencias';
      END IF;

      V_DESC := 'N RNF:'    || ' ' || :NEW.NRNUMERNF  || ' ' ||
                'Transacao:' || ' ' || V_TIPOOPERNF;

      V_IDTIPOOPER := 'I';

      V_CDFILIAL   := :NEW.CDFILIAL;

      IF NOT (V_DESC IS NULL) THEN

         V_DESC := SUBSTR(V_DESC, 1, 100);

         INSERT INTO LOGOPERAESPE (NMOPERAESPE,     DTOPERAESPE,     IDOPERAESPE,
                                   CDOPERRESPOPERA, DSOPERAESPE, CDFILIRESPOPERA)
                     VALUES ('Geracao RNF', SYSDATE,      V_IDTIPOOPER,
                             V_CDOPERADOR,  V_DESC, V_CDFILIAL);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SDXLOG_GERARNF','5.05.021'); END;
/

