/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FABR                                                     */
/* Tabela : FABRICANTE                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FABR' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FABR
GO

CREATE TRIGGER DTULTATU_FABR
ON FABRICANTE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FABRICANTE', null, 'CDFABRIC='+ CDFABRIC+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FABRICANTE
      SET DTULTATUFABR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(FABRICANTE.CDFABRIC,0)  = ISNULL(INSERTED.CDFABRIC,0));
   END;
END;
GO

